package solutions.bitbadger.documents.sqlite

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.assertThrows
import solutions.bitbadger.documents.DocumentException
import solutions.bitbadger.documents.common.Delete
import kotlin.test.Test

@DisplayName("SQLite - Delete")
class DeleteIT {

    @Test
    @DisplayName("byId deletes a matching ID")
    fun byIdMatch() =
        SQLiteDB().use(Delete::byIdMatch)

    @Test
    @DisplayName("byId succeeds when no ID matches")
    fun byIdNoMatch() =
        SQLiteDB().use(Delete::byIdNoMatch)

    @Test
    @DisplayName("byFields deletes matching documents")
    fun byFieldsMatch() =
        SQLiteDB().use(Delete::byFieldsMatch)

    @Test
    @DisplayName("byFields succeeds when no documents match")
    fun byFieldsNoMatch() =
        SQLiteDB().use(Delete::byFieldsNoMatch)

    @Test
    @DisplayName("byContains fails")
    fun byContainsMatch() {
        assertThrows<DocumentException> { SQLiteDB().use(Delete::byContainsMatch) }
    }

    @Test
    @DisplayName("byJsonPath fails")
    fun byJsonPathMatch() {
        assertThrows<DocumentException> { SQLiteDB().use(Delete::byJsonPathMatch) }
    }
}
